﻿-- REQUIRED Combuctor
local CombuctorSet = Combuctor:GetModule("Sets")

-- Profession Icon Name
local IconPathName = "Interface/Icons/Trade_tailoring"

-- AucItemClasses
local Class_Recipe 				= select(7, GetAuctionItemClasses())
local Class_Bags 				= select(3, GetAuctionItemClasses())
local Class_ArmorHeader 	= select(2, GetAuctionItemClasses())

-- AucItemSubClasses
local SubClass_Tailoring 		= select(3, GetAuctionItemSubClasses(7))
local SubClass_Materials 	= select(12, GetAuctionItemSubClasses(6))
local SubClass_Armor 			= select(2, GetAuctionItemSubClasses(2))
local SubClass_Other 			= select(13, GetAuctionItemSubClasses(6))

-- Tab Names
local TN = {}
TN.BagType_Tailoring = SubClass_Tailoring
TN.All = ALL

TN.Materials = SubClass_Materials
TN.ArmorHeader = Class_ArmorHeader
TN.Armor = SubClass_Armor
TN.Bags = Class_Bags
TN.Other = SubClass_Other
TN.Recipe = Class_Recipe

TN.TailoringRecipe = SubClass_Tailoring

-----------------------------------------------------------------------------------------------------------------------------------------
local function GetItemIDFromLink(itemLink)
				if not itemLink or itemLink=="" then return nil end

				local itemString = string.match(itemLink, "item[%-?%d:]+")
				local linkType, itemId, enchantId,jewelId1, jewelId2, jewelId3, jewelId4,suffixId, uniqueId = strsplit(":", itemString)
				if (linkType == 'item') then
				return itemId
				end
end
-----------------------------------------------------------------------------------------------------------------------------------------
function 	isTailoring(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return 	isTailoringMaterials(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				or isArmor(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				or isBag(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				or isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				or isTailoringRecipe(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc);
end
-----------------------------------------------------------------------------------------------------------------------------------------
function 	isTailoringMaterials(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				if not subType then return false end
				if not link then return false end

				local ItemID=GetItemIDFromLink(link)
				if not ItemID then return false end
	
				return Materiels_Couture[tonumber(ItemID)]
end
-----------------------------------------------------------------------------------------------------------------------------------------
function 	isArmor(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				if not subType then return false end
				if not link then return false end

				local ItemID=GetItemIDFromLink(link)
				if not ItemID then return false end
	
				return Armures_Couture[tonumber(ItemID)]
end
-----------------------------------------------------------------------------------------------------------------------------------------
function 	isBag(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				if not subType then return false end
				if not link then return false end

				local ItemID=GetItemIDFromLink(link)
				if not ItemID then return false end
	
				return Sac_Couture[tonumber(ItemID)]
end
-----------------------------------------------------------------------------------------------------------------------------------------
function 	isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				if not subType then return false end
				if not link then return false end

				local ItemID=GetItemIDFromLink(link)
				if not ItemID then return false end
	
				return Divers_Couture[tonumber(ItemID)] or ( Armures_Couture[tonumber(ItemID)] == nil and type == TN.ArmorHeader and subType == TN.Armor )
end
-----------------------------------------------------------------------------------------------------------------------------------------
function 	isTailoringRecipe(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
				return (subType == TN.TailoringRecipe)
end
-----------------------------------------------------------------------------------------------------------------------------------------

CombuctorSet:Register(TN.BagType_Tailoring, IconPathName, isTailoring)

CombuctorSet:RegisterSubSet(TN.All,               		TN.BagType_Tailoring, nil, isTailoring)
CombuctorSet:RegisterSubSet(TN.Materials,			TN.BagType_Tailoring, nil, isTailoringMaterials)
CombuctorSet:RegisterSubSet(TN.ArmorHeader,	TN.BagType_Tailoring, nil, isArmor)
CombuctorSet:RegisterSubSet(TN.Bags,					TN.BagType_Tailoring, nil, isBag)
CombuctorSet:RegisterSubSet(TN.Other,				TN.BagType_Tailoring, nil, isOther)
CombuctorSet:RegisterSubSet(TN.Recipe,				TN.BagType_Tailoring, nil, isTailoringRecipe)
